% Generamos una señal CBOC.
% Se requiere que la relación entre ambas señales sean multiplos  enteros 
% en longitud y que sean señales BOC válidas

% Paneles
apagar_sqrrc;
apagar_boc;
encender_cboc;

% Recopilamos handels

nombre_senal = findobj(gcbf, 'Tag', 'panel_senal'); 

num_muestras = findobj(gcbf, 'Tag', 'num_muestras');
dur_senal    = findobj(gcbf, 'Tag', 'duracion_senal');
res_senal    = findobj(gcbf, 'Tag', 'res_senal');

amplis = findobj(gcbf, 'Tag', 'amplitudes');

h_m1 = findobj(gcbf, 'Tag', 'cboc_m1');
h_n1 = findobj(gcbf, 'Tag', 'cboc_n1');
h_m2 = findobj(gcbf, 'Tag', 'cboc_m2');
h_n2 = findobj(gcbf, 'Tag', 'cboc_n2');
h_p1 = findobj(gcbf, 'Tag', 'p1');
h_p2 = findobj(gcbf, 'Tag', 'p2');

if default == 1

        set(res_senal, 'String', '250');
        set(dur_senal, 'String', '0.9775');
        
        set(h_m1, 'String', '1');
        set(h_n1, 'String', '1');
        
        set(h_m2, 'String', '6');
        set(h_n2, 'String', '1');
        
        set(h_p1, 'String', '10/11');
        set(h_p2, 'String', '1/11');
end

% Recopilamos datos

m1 = str2num(get(h_m1, 'String'));
n1 = str2num(get(h_n1, 'String'));

m2 = str2num(get(h_m2, 'String'));
n2 = str2num(get(h_n2, 'String'));


p1 = sqrt(str2num(get(h_p1, 'String')));
p2 = sqrt(str2num(get(h_p2, 'String')));

Tc1 = 2*(m1/n1);
Tc2 = 2*(m2/n2);

% Proporción entre señales
test = max(Tc1/Tc2, Tc2/Tc1);

% La señal 1 será la más larga de las dos
if Tc1 <= Tc2
    aux = Tc1; Tc1 = Tc2 ; Tc2 = aux;
    aux = p1 ; p1  = p2  ; p2  = aux;
end

boc1 = [];
boc2 = [];

if Tc1 == floor(Tc1) && Tc2 == floor(Tc2) && test == floor(test) 
 
    % La señal final no va a ser mas larga que la mas larga
    sinus = ones(1, Tc1); 
    
    % La parte larga alterna signos tantos como sea de larga.
    
    for k = 1 : Tc1    
            boc1 = [boc1 (sinus(k)*((-1)^(k+1)))*p1];
    end
    
    % La parte corta envuelve la larga. Mantienes el signo tantas veces
    % como lo marque la relación entre las señales.
    for k = 1 : Tc2    
            mijita = sinus(k)*((-1)^(k+1))*p2;
            for l = 1 : test
                boc2 = [boc2 mijita];
            end
    end
    
    h1 = findobj(gcbf, 'Tag', 'cboc_mas_menos');
    h_gnss = findobj(gcbf, 'Tag', 'desplegable_gnss');
    z = get(h_gnss, 'userData');
    j=z(1);
    
    if get(h1, 'Value') == 0
        cboc = boc1 + boc2;
        set(nombre_senal, 'Title', 'CBOC(+)')
        k = 6;
    else
        cboc = boc2 - boc1;
        set(nombre_senal, 'Title', 'CBOC(-)')
        k = 61;
    end
    
    set(h_gnss, 'UserData', [j k]);  
    
    set(num_muestras, 'String', length(cboc),'BackgroundColor', [0.5 0.5 0.5],...
    'Enable', 'inactive');

else
    % Alguno de los motivos no permite generar la señal 
    set(amplis, 'String','  '); 
    set(num_muestras, 'String', '**');
    cboc = [0];   
end

set(amplis, 'String',num2str(cboc));

% Representamos la señal con los datos que tenemos

    h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
    h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);
    
    % Cosmética
    
    %stairs(h_temp, [cboc cboc(end)])
    stem(h_temp, cboc)

    ylim(h_temp,[min(-0.1, min(cboc))*1.2 max(0.1, max(cboc))*1.2])
    xlim(h_temp, [0 length(cboc)+1])

    grid(h_temp, 'on')






