function varargout = CCR(varargin)
%CCR M-file for CCR.fig
%      CCR, by itself, creates a new CCR or raises the existing
%      singleton*.
%
%      H = CCR returns the handle to a new CCR or the handle to
%      the existing singleton*.
%
%      CCR('Property','Value',...) creates a new CCR using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to CCR_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      CCR('CALLBACK') and CCR('CALLBACK',hObject,...) call the
%      local function named CALLBACK in CCR.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CCR

% Last Modified by GUIDE v2.5 30-May-2011 11:48:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CCR_OpeningFcn, ...
                   'gui_OutputFcn',  @CCR_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT

% --- Executes just before CCR is made visible.
function CCR_OpeningFcn(hObject, eventdata, handles, varargin)

%Creamos algunos datos para una señal sencilla

handles.current_data=ones(1,6);
  
h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);

stem(h_temp, handles.current_data);
ylim(h_temp, [0 1.2])
xlim(h_temp, [0 7])
grid(h_temp, 'on')

% Choose default command line output for CCR
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CCR wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = CCR_OutputFcn(hObject, eventdata, handles)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in representar.
function representar_Callback(hObject, eventdata, handles)

% Tomemos los datos que nos hacen falta del GUI

% Lo que dura cada muestra en tiempo. Normalmente us
h1 = findobj(gcbf, 'Tag', 'duracion_senal');
T  = str2num(get(h1, 'String'));

% Las muestras que tiene la señal en origen
h1 = findobj(gcbf, 'Tag', 'num_muestras');
Ts = str2num(get(h1, 'String'));

% Factor para hacer zero padding
h1 = findobj(gcbf, 'Tag', 'res_senal');
r  = str2num(get(h1, 'String'));

% Opciones de representación.
% Varias gráficas superpuestas
h1 = findobj(gcbf, 'Tag', 'fix');
fix = get(h1, 'value');

% El color de la señal siempre que pulso Representar es magenta
% Cuando he pulsado 'color' será uno aleatorio
% Cuando he pulsado 'usar ' será el color definido

h1 = findobj(gcbf, 'Tag', 'color');
h2 = findobj(gcbf, 'Tag', 'color_senal');
h3 = findobj(gcbf, 'Tag', 'usar');

if get(h1, 'UserData') == 1
    set(h2, 'String', rand(1, 3))
    set(h1, 'UserData', num2str(0))
else
    if get(h3, 'UserData')  ~= 1
        set(h2, 'String', [1 0 1])
    else
        set(h3, 'UserData', num2str(0))
    end
end


% La señal
h1 = findobj(gcbf, 'Tag', 'amplitudes');
x  = str2num(get(h1, 'String'));

% ... y llamamos a la representación

periodograma();
crb2();
check_signal_ccr();
representa();

% --- Executes on selection change in desplegable_gnss.
function desplegable_gnss_Callback(hObject, eventdata, handles)

% Obtengamos los datos de señales predefinidas

% El primer color con el que dibujo es con magenta.
h1 = findobj(gcbf, 'Tag', 'color_senal');
set(h1, 'String', '1 0 1')

val=get(hObject,'Value');
str=get(hObject,'String');

default = 1;

switch str{val}
    
    case 'Pulso Rectangular' 
 
        pulse_generator_ccr;
         
    case 'BOC' 
        
        boc_generator_ccr;
    
    case 'SQRRC' 
        
        sqrrc_generator_ccr;
       
    case 'GPS-L1'
        
        gps_L1_generator_ccr;
        
    case 'CBOC Galileo E1'
           
        E1_generator_ccr;
end

function encender_sqrrc()
        
        h1=findobj(gcbf, 'Tag', 'panel_sqrrc');
        set(h1,  'Visible', 'on')
        
function apagar_sqrrc()
        
        h1=findobj(gcbf, 'Tag', 'panel_sqrrc');
        set(h1,  'Visible', 'off')
        
function encender_boc()

        h1=findobj(gcbf, 'Tag', 'panel_boc');
        set(h1,  'Visible', 'on')
                     
 function apagar_boc()
        
        h1=findobj(gcbf, 'Tag', 'panel_boc');
        set(h1,  'Visible', 'off')


% --- Executes during object creation, after setting all properties.
function desplegable_gnss_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function res_senal_Callback(hObject, eventdata, handles)

function res_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function BOC_m_Callback(hObject, eventdata, handles)
default = 0;
boc_generator_ccr;

function BOC_n_Callback(hObject, eventdata, handles)
default = 0;
boc_generator_ccr;

% --- Executes during object creation, after setting all properties.
function BOC_m_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function BOC_n_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---
function duracion_senal_Callback(hObject, eventdata, handles)
% Aunque toque aquí no hay cambio en el resto. El valor queda almacenado 

% --- Executes during object creation, after setting all properties.
function duracion_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---
function num_muestras_Callback(hObject, eventdata, handles)
default = 0;
pulse_generator_ccr;

% --- Executes during object creation, after setting all properties.
function num_muestras_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function representar_CreateFcn(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function panel_principal_CreateFcn(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function grafica_dep_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in periodograma.
function periodograma_Callback(hObject, eventdata, handles)

function roll_off_Callback(hObject, eventdata, handles)
    % Parámetro exclusivo de SQRRC. Recalculamos y dibujamos
    default = 0;
    sqrrc_generator_ccr;
    

% --- Executes during object creation, after setting all properties.
function roll_off_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---
function ls_Callback(hObject, eventdata, handles)
    % Parámetro exclusivo de SQRRC. Recalculamos y dibujamos
    default = 0;
    sqrrc_generator_ccr; 
    
    
% --- Executes during object creation, after setting all properties.
function ls_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function nss_Callback(hObject, eventdata, handles)
    % Parámetro exclusivo de SQRRC. Recalculamos y dibujamos
    default = 0;
    sqrrc_generator_ccr;
    
% --- Executes on button press in fix.
function fix_Callback(hObject, eventdata, handles)    

    
% --- Executes on button press in clear.
function clear_Callback(hObject, eventdata, handles)

% --- Executes on button press in log_dep.
function log_dep_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function nss_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ancho_banda_receptor_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function ancho_banda_receptor_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ruido_min_Callback(hObject, eventdata, handles)

% No permitimos valores absurdos
min_ = str2num(get(hObject,'String'));
h2  = findobj(gcbf, 'Tag', 'ruido_max');
max_ = str2num(get(h2,'String'));
if min_ > max_
    set(hObject, 'String', num2str(max_))
end

% --- Executes during object creation, after setting all properties.
function ruido_min_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ruido_max_Callback(hObject, eventdata, handles)

% No permitimos valores absurdos
max_ = str2num(get(hObject,'String'));
h2  = findobj(gcbf, 'Tag', 'ruido_min');
min_ = str2num(get(h2,'String'));
if max_ < min_
    set(hObject, 'String', num2str(min_))
end

% --- Executes during object creation, after setting all properties.
function ruido_max_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function fix_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in almacenar.
function almacenar_Callback(hObject, eventdata, handles)

store_ccr

% --- Executes on button press in usar.
function usar_Callback(hObject, eventdata, handles)
set(hObject, 'UserData', 1)
usar_ccr
representar_Callback()
    
% --- Executes on button press in senal_2.
function senal_2_Callback(hObject, eventdata, handle)

% --- Executes during object creation, after setting all properties.
function datos_senal_1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_1_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function datos_senal_2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_2_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function datos_senal_3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_3_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function datos_senal_4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_4_Callback(hObject, eventdata, handles)


% --- Executes on button press in color.
function color_Callback(hObject, eventdata, handles)

%h1 = findobj(gcbf, 'Tag', 'color_senal');
%set(h1, 'String', rand(1, 3))
set(hObject, 'UserData', 1)
representar_Callback()
