% Generamos una señal Galileo E1 que es un combo de BOC(1,1) y BOC(6,1)
% balanceadas en potencia y sumadas
% Una opción podría ser la versión (+), (-), (+,-)

Tc = 12;      
cboc61 = [];
sinus  = ones(1, Tc);

for k = 1 : Tc    
    cboc61 = [cboc61 (sinus(k)*((-1)^(k+1)))];
end

cboc61 = cboc61.*sqrt(1/11);
cboc11 = [ones(1,6) ones(1,6)*(-1)].*sqrt(10/11);

galileoE1 = cboc61 + cboc11;

% Representamos la señal

    h1 = findobj(gcbf, 'Tag', 'amplitudes');
    amplitudes = str2num(get(h1, 'String'));
    
    h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
    h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);

    stem(h_temp, galileoE1)
    
    ylim(h_temp,[min(galileoE1)*1.2 max(galileoE1)*1.2])
    xlim(h_temp, [0 length(galileoE1)+1])
    
    grid(h_temp, 'on')

% Actualizamos los datos de trabajo

apagar_sqrrc;
apagar_boc;
apagar_cboc;

h1 = findobj(gcbf, 'Tag', 'amplitudes');
set(h1, 'String',num2str(galileoE1));

num_muestras = findobj(gcbf, 'Tag', 'num_muestras');
set(num_muestras, 'String', length(galileoE1),'BackgroundColor', [0.5 0.5 0.5], 'Enable', 'inactive');

nombre_senal = findobj(gcbf, 'Tag', 'panel_senal');
set(nombre_senal, 'Title', 'Galileo E1 - CBOC(6,1, 1/11)')

dur_senal = findobj(gcbf, 'Tag', 'duracion_senal');
res_senal = findobj(gcbf, 'Tag', 'res_senal');


h_gnss = findobj(gcbf, 'Tag', 'desplegable_gnss');

z = get(h_gnss, 'userData');
j = z(1); 
set(h_gnss, 'UserData', [j,5]);  

if default == 1
    set(res_senal, 'String', '200')
    set(dur_senal, 'String', '0.9775')
end

    

        
