function varargout = FA(varargin)
% FA M-file for FA.fig
%      FA, by itself, creates a new FA or raises the existing
%      singleton*.
%
%      H = FA returns the handle to a new FA or the handle to
%      the existing singleton*.
%
%      FA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FA.M with the given input arguments.
%
%      FA('Property','Value',...) creates a new FA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FA_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FA_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FA

% Last Modified by GUIDE v2.5 19-May-2011 21:43:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FA_OpeningFcn, ...
                   'gui_OutputFcn',  @FA_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FA is made visible.
function FA_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FA (see VARARGIN)

% Choose default command line output for FA
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FA wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FA_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


% --- Executes on button press in representar.
function representar_Callback(hObject, eventdata, handles)

h_f_fasis  = findobj(gcbf, 'Tag', 'fix_fasis');
h_f_modis  = findobj(gcbf, 'Tag', 'fix_modis');

h_amplis = findobj(gcbf, 'Tag', 'amplitudes');

amplitudesGruesas  = str2num(get(h_amplis, 'String'));

Nor  = length(amplitudesGruesas);

h_fasis = findobj(gcbf, 'Tag', 'fases');

if get(h_f_fasis, 'Value') == 1

   fasesGruesas = str2num(get(h_fasis, 'String'));
else
   fasesGruesas = zeros(1, length(amplitudesGruesas));
end

% Si modulamos en frecuencia, la "nueva" fase de cada muestra depende de los
% valores de la modulación

h_modis = findobj(gcbf, 'Tag', 'mod_frec');
new_fase = fasesGruesas;

if get(h_f_modis, 'Value') == 1

    mod_frec = str2num(get(h_modis, 'String'));
else
    mod_frec = zeros(1, length(amplitudesGruesas));
end

new_fase = new_fase + 2 * pi * cumsum(mod_frec);
expos = exp(1i*pi*new_fase);
sGruesa = amplitudesGruesas.* expos;
                                      
h1 = findobj(gcbf, 'Tag', 'res_senal');
r  = str2num(get(h1, 'String'));

% Tema CRUCIAL: aproximar las curvas
% De momento escalonamos los puntos intermedios. 

% El número total de muestras o divisiones en el tiempo N no puede ser un 
% valor cualquiera. Depende de r y No. Tampoco puedo asignar un
% valora arbitrario a las divisiones si quiero respetar el número de 
% muestras finales respecto a las originales.

divisiones = floor((r*(Nor-1) + Nor)/Nor);
N = Nor * divisiones;

% Replicamos cada muestra original (divisiones - 1 veces)

s = [];

for z = 1 : Nor
    s=[s sGruesa(z)];
    for zz = 1 : divisiones-1
        s =[s sGruesa(z)];
    end
end

h_dur_senal = findobj(gcbf, 'Tag', 'dur_senal');
dur_senal = str2num(get(h_dur_senal, 'String'));

h1 = findobj(gcbf, 'Tag', 'res_frec');
num_f  = str2num(get(h1, 'String'));

h1 = findobj(gcbf, 'Tag', 'frec_max');
flimite  = str2num(get(h1, 'String'));

h1 = findobj(gcbf, 'Tag', 'pos_neg');
neg = get(h1, 'value');

h1=findobj(gcbf, 'Tag', 'tresd_contour');
tresd = get(h1, 'value');

% ... y llamamos a la función que dibuja

representa_fa ;

function amplitudes_Callback(hObject, eventdata, handles)

% Cuando el usuario modifica la señal, se cambia el nombre en GUI

% Si tocamos aqui hay que actualizar n y modificar el nombre de la señal
calculo_de_n

nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');
set(nombre_senal, 'String', 'Señal usuario')

% --- Executes during object creation, after setting all properties.
function amplitudes_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function fases_Callback(hObject, eventdata, handles)

% Si tocamos aqui hay que actualizar n y modificar el nombre de la señal
calculo_de_n

nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');
set(nombre_senal, 'String', 'Señal usuario')


% --- Executes during object creation, after setting all properties.
function fases_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function res_senal_Callback(hObject, eventdata, handles)

% Si tocamos aqui hay que actualizar n
calculo_de_n

% --- Executes during object creation, after setting all properties.
function res_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function res_frec_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function res_frec_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function frec_max_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function frec_max_Callback(hObject, eventdata, handles)

% --- Executes on selection change in predefinidas.
function predefinidas_Callback(hObject, eventdata, handles)

val=get(hObject,'Value');
str=get(hObject,'String');

amplis       = findobj(gcbf, 'Tag', 'amplitudes');  % Vector de amplitudes
fasis        = findobj(gcbf, 'Tag', 'fases');       % Vector de las fases
modis        = findobj(gcbf, 'Tag', 'mod_frec');    % Vector de modulacion en frecuencia
nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');% Nombre de la señal
res_senal    = findobj(gcbf, 'Tag', 'res_senal');   % En cuanto queremos dividir cada muestra
res_frec     = findobj(gcbf, 'Tag', 'res_frec');    % Cuantas divisiones de frecuencias queremos usr
frec_max     = findobj(gcbf, 'Tag', 'frec_max');    % Frec. máxima. A partir de 0.5 se repite. Investigar

h_f_fasis  = findobj(gcbf, 'Tag', 'fix_fasis');
h_f_modis  = findobj(gcbf, 'Tag', 'fix_modis');

h_pos_neg  = findobj(gcbf, 'tag', 'pos_neg');

switch str{val}
    
    case 'Pulso Rectangular' 
        
       % Aquí hago los settings y actualizo los cajetines
       % Cuando añadimos uno nuevo no olvidar de actualizar el desplegable
       % del GUI.
        set(amplis, 'String', '1 1 1 1 1')
        set(fasis,  'String', '0 0 0 0 0')
        set(modis,  'String', '0 0 0 0 0')
        
        set(h_f_fasis,  'Value', 0)
        set(h_f_modis,  'Value', 0)
        
        set(h_pos_neg,  'Value', 0)
        
        set(nombre_senal, 'String', 'Pulso Rectangular')
        set(res_senal,    'String', '15')
        set(res_frec,     'String', '45')
        set(frec_max,     'String', '0.078')
        
        calculo_de_n
        
        apagar_BOC
        encender_cajetines
        
    case 'Tren de Pulsos' 
        
        set(amplis, 'String', '1 0 1 0 1 0 1 0 1 0') 
        set(fasis,  'String', '0 0 0 0 0 0 0 0 0 0')
        set(modis,  'String', '0 0 0 0 0 0 0 0 0 0')

        set(h_f_fasis,  'Value', 0)
        set(h_f_modis,  'Value', 0)
        
        set(h_pos_neg,  'Value', 1)
        
        set(nombre_senal, 'String', 'Tren de Pulsos')
        set(res_senal,    'String', '8')
        set(res_frec,     'String', '60')
        set(frec_max,     'String', '0.3')
        
        calculo_de_n
        
        apagar_BOC
        encender_cajetines
        
    case 'Barker 13' % Típico codificado en fase
        
        set(amplis, 'String', '1 1 1 1 1 1 1 1 1 1 1 1 1') 
        set(fasis,  'String', '1 1 1 1 1 0 0 1 1 0 1 0 1')
        set(modis,  'String', '0 0 0 0 0 0 0 0 0 0 0 0 0')

        set(h_f_fasis,  'Value', 1)
        set(h_f_modis,  'Value', 0)
        
        set(h_pos_neg,  'Value', 1)
        
        set(nombre_senal, 'String', 'Barker 13')
        set(res_senal,    'String', '12')
        set(res_frec,     'String', '20')
        set(frec_max,     'String', '0.25')   
        
        calculo_de_n
        
        apagar_BOC
        encender_cajetines
        
    case 'Pulso LFM' % Típico de frecuencia modulada. Ver como gira.
        
        set(amplis, 'String', '1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1'); 
        set(fasis,  'String', '0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0');
        set(modis,  'String', '-.04 -.035 -.03 -.025 -.02 -.015 -.01 -.005 0 .005 .01 .015 .02 .025 .03 .035 .04');
        
        set(h_f_fasis,  'Value', 0)
        set(h_f_modis,  'Value', 1)
        
        set(h_pos_neg,  'Value', 1)
        
        set(nombre_senal, 'String', 'Pulso modulado (LFM)');
        set(res_senal,    'String', '5');
        set(res_frec,     'String', '15');
        set(frec_max,     'String', '0.08');  
        
        calculo_de_n
        
        apagar_BOC
        encender_cajetines
               
    case 'BOC' % A ver com ogestionamos esto con los cajetines.
        
        % Esta señal es de una naturaleza distinta a las otras. 
        % Los datos que se piden son otros.
        % Anulamos el panel y ponemos otro.
        
        apagar_cajetines
        encender_BOC
        
        h1 = findobj(gcbf, 'Tag', 'BOC_m');
        set(h1, 'String', '3');
        
        h1 = findobj(gcbf, 'Tag', 'BOC_n');
        set(h1, 'String', '2');
        
        set(amplis, 'String', ''); 
        set(fasis,  'String', '');
        set(modis,  'String', '');
                       
        set(nombre_senal, 'String', 'BOC');
        set(res_senal,    'String', '40');
        set(res_frec,     'String', '50');
        set(frec_max,     'String', '0.2');  
        
        set(h_f_fasis,  'Value', 0)
        set(h_f_modis,  'Value', 0)                                
        
        set(h_pos_neg,  'Value', 1)
end

function calcular_boc()
        
        amplis = findobj(gcbf, 'Tag', 'amplitudes');
        fasis  = findobj(gcbf, 'Tag', 'fases');          
        modis  = findobj(gcbf, 'Tag', 'mod_frec'); 
        
        h1 = findobj(gcbf, 'Tag', 'BOC_m');
        boc_m  = str2num(get(h1, 'String'));
        h1 = findobj(gcbf, 'Tag', 'BOC_n');
        boc_n  = str2num(get(h1, 'String'));

        % Periodo de chip Tc
        
        Tc = 2*(boc_m/boc_n); % Tc es el número de medias sinusoides que debemos 
                              % tomar para construir el chip BOC
        
        if Tc == floor(Tc) % la relación 2* m/n es un entero
            
            nada  = zeros(1 , Tc);
            sinus = ones(1 , Tc);
            amp   = [];
            
            for k = 1 : Tc    
                amp = [amp (sinus(k)*((-1)^(k+1)))];
            end
            
            set(amplis, 'String', num2str(amp))
            set(fasis,  'String', num2str(nada))
            set(modis, 'String', num2str(nada))
           
            calculo_de_n 
        
        else
            
        % Se produce un error y no actualizamos nada. Queda fatal.
        % ¿Ventana emergente? En cualquier caso colocamos nada en el
        % el cajetín  
        
            set(amplis, 'String', '* * * * *'); 
            set(fasis,  'String', '');
            set(modis,  'String', '');  
        
        end

function encender_cajetines()

        h1=findobj(gcbf, 'Tag', 'text_mod_en_frec');
        set(h1, 'Visible', 'on')
        modis  = findobj(gcbf, 'Tag', 'mod_frec'); 
        set(modis,  'Visible', 'on')    
        h1=findobj(gcbf, 'Tag', 'text_fases');
        set(h1, 'Visible', 'on') 
        fasis  = findobj(gcbf, 'Tag', 'fases'); 
        set(fasis,  'Visible', 'on')
        amplis  = findobj(gcbf, 'Tag', 'amplitudes');
        set(amplis,  'BackgroundColor', [.831 .816 .784] )
        set(amplis,  'Enable', 'on')
        
        h_f_fasis  = findobj(gcbf, 'Tag', 'fix_fasis');
        h_f_modis  = findobj(gcbf, 'Tag', 'fix_modis');
        set(h_f_fasis, 'Visible', 'on')
        set(h_f_modis, 'Visible', 'on')
        
function apagar_cajetines()

        h1=findobj(gcbf, 'Tag', 'text_mod_en_frec');
        set(h1, 'Visible', 'off')
        modis  = findobj(gcbf, 'Tag', 'mod_frec'); 
        set(modis,  'Visible', 'off')        
        h1=findobj(gcbf, 'Tag', 'text_fases');
        set(h1, 'Visible', 'off')       
        fasis  = findobj(gcbf, 'Tag', 'fases'); 
        set(fasis,  'Visible', 'off')
        amplis  = findobj(gcbf, 'Tag', 'amplitudes'); 
        set(amplis,  'BackgroundColor', [.50 .50 .50] )
        set(amplis,  'Enable', 'inactive')
                
        h_f_fasis  = findobj(gcbf, 'Tag', 'fix_fasis');
        h_f_modis  = findobj(gcbf, 'Tag', 'fix_modis');
        set(h_f_fasis, 'Visible', 'off')
        set(h_f_modis, 'Visible', 'off')
        
function encender_BOC()

        h1=findobj(gcbf, 'Tag', 'text_m');
        h2=findobj(gcbf, 'Tag', 'text_n');
        h3=findobj(gcbf, 'Tag', 'text_param_boc');
        set(h1, 'Visible', 'on')
        set(h2, 'Visible', 'on')
        set(h3, 'Visible', 'on')
        h1=findobj(gcbf, 'Tag', 'BOC_m');
        h2=findobj(gcbf, 'Tag', 'BOC_n');
        h3=findobj(gcbf, 'Tag', 'calc_boc');       
        set(h1, 'Visible', 'on')
        set(h2, 'Visible', 'on')
        set(h3, 'Visible', 'on')  

function apagar_BOC()

        h1=findobj(gcbf, 'Tag', 'text_m');
        h2=findobj(gcbf, 'Tag', 'text_n');
        h3=findobj(gcbf, 'Tag', 'text_param_boc');
        set(h1, 'Visible', 'off')
        set(h2, 'Visible', 'off')
        set(h3, 'Visible', 'off')
        h1=findobj(gcbf, 'Tag', 'BOC_m');
        h2=findobj(gcbf, 'Tag', 'BOC_n');
        h3=findobj(gcbf, 'Tag', 'calc_boc');
        set(h1, 'Visible', 'off')
        set(h2, 'Visible', 'off')     
        set(h3, 'Visible', 'off')      

% --- Executes during object creation, after setting all properties.
function predefinidas_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function grafica_CreateFcn(hObject, eventdata, handles)

function panel_FA_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in pos_neg.
function pos_neg_Callback(hObject, eventdata, handles)

function mod_frec_Callback(hObject, eventdata, handles)

calculo_de_n

nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');
set(nombre_senal, 'String', 'Señal usuario');

% --- Executes during object creation, after setting all properties.
function mod_frec_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in tresd_contour.
function tresd_contour_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function n_usadas_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in n_usadas.
function n_usadas_Callback(hObject, eventdata, handles)


function calculo_de_n()

amplis    = findobj(gcbf, 'Tag', 'amplitudes');       
res_senal = findobj(gcbf, 'Tag', 'res_senal');      % En cuanto queremos dividir cada muestra
n_usadas  = findobj(gcbf, 'Tag', 'n_usadas');

muestras  = length(str2num(get(amplis, 'String')));

res  = str2num(get(res_senal, 'String'));
divs = floor((res*(muestras-1) + muestras)/muestras);
n_u = muestras * divs;

set(n_usadas, 'String', n_u)

% --- Executes during object creation, after setting all properties.
function BOC_m_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function BOC_m_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function BOC_n_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function BOC_n_Callback(hObject, eventdata, handles)

% --- Executes on button press in calc_boc.
function calc_boc_Callback(hObject, eventdata, handles)

calcular_boc


% --- Executes during object creation, after setting all properties.
function dur_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function dur_senal_Callback(hObject, eventdata, handles)


% --- Executes on button press in fix_fasis.
function fix_fasis_Callback(hObject, eventdata, handles)


% --- Executes on button press in fix_modis.
function fix_modis_Callback(hObject, eventdata, handles)
