% Generamos una señal BOC

% Mostramos el panel apropiado y ocultamos los no necesarios
        
encender_boc;
apagar_sqrrc;
apagar_cboc;

num_muestras = findobj(gcbf, 'Tag', 'num_muestras'); 
res  = findobj(gcbf, 'Tag', 'res_senal');            
dur_senal = findobj(gcbf, 'Tag', 'duracion_senal');  
amplis = findobj(gcbf, 'Tag', 'amplitudes');

nombre_senal = findobj(gcbf, 'Tag', 'panel_senal');  % Nombre de la señal
set(nombre_senal, 'Title', 'BOC');

h_boc_m = findobj(gcbf, 'Tag', 'BOC_m');
h_boc_n = findobj(gcbf, 'Tag', 'BOC_n');

if default == 1

        set(res, 'String', '400');
        set(dur_senal, 'String', '0.9775');
        
        set(h_boc_m, 'String', '2');
        set(h_boc_n, 'String', '2');
end

% Recopilamos los datos del GUI

boc_m  = str2num(get(h_boc_m, 'String'));
boc_n  = str2num(get(h_boc_n, 'String'));

% Periodo de chip Tc
        
Tc = 2*(boc_m/boc_n); % Tc es el número de medias sinusoides que debemos 
                      % tomar para construir el chip BOC
amplitudes = []; 

    if Tc == floor(Tc)    % la relación 2* m/n es un entero
            
        sinus = ones(1, Tc);
            
        for k = 1 : Tc    
            amplitudes = [amplitudes (sinus(k)*((-1)^(k+1)))];
        end

        set(amplis, 'String',num2str(amplitudes));
        set(num_muestras, 'String', Tc,'BackgroundColor', [0.5 0.5 0.5],...
            'Enable', 'inactive');
                
    else
        % Se produce un error y no actualizamos nada. Queda fatal.
        % ¿Ventana emergente? En cualquier caso colocamos nada (**) en el
        % el cajetín y eventualmente podríamos poner en rojo la opción de 
        % representar.
        
        set(amplis, 'String','  '); 
        set(num_muestras, 'String', '**');
        amplitudes = [0];
    end

h_gnss = findobj(gcbf, 'Tag', 'desplegable_gnss');
z = get(h_gnss, 'userData');
j = z(1); 
set(h_gnss, 'UserData', [j,3]);  
    
% Representamos la señal

h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);

% Un poco de cosmética en la representación (no en los cálculos)

stem(h_temp, amplitudes); 

ylim(h_temp,[-1.2 +1.2])
xlim(h_temp, [0 length(amplitudes)+1])
grid(h_temp, 'on') 

