%% Cálculo del CRB

% Para representar el CRB necesitamos calcular el ancho de banda cuadrático
% medio o de Gabor. Tomamos las distribución espectral en potencia de la
% señal (ya calculado)

% Recabamos datos. Límites de potencia señal frente al ruido y el ancho de
% banda del receptor.

h1=findobj(gcbf, 'Tag', 'ruido_min');
h2=findobj(gcbf, 'Tag', 'ruido_max');
h3=findobj(gcbf, 'Tag', 'ancho_banda_receptor');

mn = str2num(get(h1, 'String'));
mx = str2num(get(h2, 'String'));
B  = str2num(get(h3, 'String'));

% Tomamos la densidad espectral
Z2 = Zz; %.^2;

% Limite de integración en Hz. Ts es el numero de muestras, T lo que dura
% cada una de ellas en us

l_sup = Ts/(2*T*10^-6);
l_inf = -l_sup;

paso = (l_sup-l_inf+1)/length(Z2);

% Generamos un vector de frecuencias

frecuencias = l_inf : paso : l_sup ;

pp = (2*pi*frecuencias).^2 ;
numer = pp.*Z2 ;

int_num3= trapz(numer)*paso;
int_den3= trapz(Z2)*paso;

% Ancho de banda de Gabor
gabi = int_num3/int_den3;


% Este es el rango C/No sobre el que representamos. Ancho de banda en Hz.

dB_range  = (mn : (mx-mn)/50 :mx);

var_tau =  ((B*10^6)./(2*(10.^(dB_range/10))*gabi)) ;
