% Aqui generamos los datos necesarios para la señal.

% Mostramos los paneles que nos pertenecen y apagamos los que no
% necesitamos

apagar_boc;
apagar_sqrrc;

num_muestras = findobj(gcbf, 'Tag', 'num_muestras'); 
res          = findobj(gcbf, 'Tag', 'res_senal');            
dur_senal    = findobj(gcbf, 'Tag', 'duracion_senal');  
nombre_senal = findobj(gcbf, 'Tag', 'panel_senal');  
amplis       = findobj(gcbf, 'Tag', 'amplitudes');

set(nombre_senal, 'Title', 'GPS-L1');

% La señal GPS no es mas que un pulso rectangular.

if default == 1
    
    set(num_muestras, 'String', '5', 'BackgroundColor', [0.5 0.5 0.5], 'Enable', 'inactive' );
    set(dur_senal, 'String', '25')
    set(res, 'String', '60')
    amplitudes = ones(1,5);
    set(amplis, 'String',num2str(amplitudes))
end

h_gnss = findobj(gcbf, 'Tag', 'desplegable_gnss');
z = get(h_gnss, 'userData');
j = z(1); 
set(h_gnss, 'UserData', [j,4]);  

amplitudes = ones(1,str2num(get(num_muestras, 'String')));
set(amplis, 'String', num2str(amplitudes)) 
   
% Representamos la señal
    
h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);

stem(h_temp, [amplitudes])

% Le damos un poco de margen para que la gráfica *respire*

ylim(h_temp,[min([0 amplitudes*1.2]) max(amplitudes)*1.2])
xlim(h_temp, [0 length(amplitudes)+1])
grid(h_temp, 'on')
