% Esta rutina hace el uso de la tecnica del periodograma para representar
% la densidad espectral de potencia.
% Sólo necesitamos la señal y calculamos la TF, calculamos el módulo y
% elevamos al cuadrado.

% Usemos un número impar de puntos. Así siempre quedará centrada

puntos = r*Ts;

% Siempre usaremos un número impar de puntos para que las gráficas queden
% centradas

if puntos/2 == floor(puntos/2)
    puntos = puntos + 1;
end

Zz = (abs(fft(x, puntos))).^2;

% Normalizamos 

Z = Zz/max(max(Zz));

% No hace falta. Es 1 por estar normalizado.
maxZ = max(Z);
minZ = min(Z);
% Hacemos un poco de "trampas" para cuando el valor mínimo es efectivamente
% cero. Así las gráficas salen mejor.

if min(Z) == 0 
    kk=sort(Z);
    minZ = kk(2);
end
   
% Centramos la densidad espectral de potencia

Z = fftshift(Z');

% Confinamos las frecuencias al intervalo [-0.5, +0.5]
eje_x=linspace( -0.5, 0.5, length(Z) );

   
    