% Generemamos un pulso rectangular

% Mostramos el panel apropiado y ocultamos los no necesarios

apagar_boc
apagar_sqrrc

% Elementos del GUI que vamos a modificar

num_muestras = findobj(gcbf, 'Tag', 'num_muestras'); 
res          = findobj(gcbf, 'Tag', 'res_senal');            
dur_senal    = findobj(gcbf, 'Tag', 'duracion_senal');   
nombre_senal = findobj(gcbf, 'Tag', 'panel_senal');  
amplis       = findobj(gcbf, 'Tag', 'amplitudes');

set(nombre_senal, 'Title', 'Pulso Rectangular');

% Si es por defecto usamos los datos por defecto.

if default == 1
    set(res, 'String', '60')
    set(dur_senal, 'String', '25')
    set(num_muestras, 'String', '5', 'BackgroundColor', [0.8 0.8 0.8], 'Enable', 'on' );
end

amplitudes = ones(1,str2num(get(num_muestras, 'String')));
set(amplis, 'String', num2str(amplitudes)) 

h_gnss = findobj(gcbf, 'Tag', 'desplegable_gnss');

z = get(h_gnss, 'userData');
j = z(1); 
set(h_gnss, 'UserData', [j,1]); 

% Representamos la señal
    
h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);

stem(h_temp, [amplitudes])

% Le damos unpoco de margen para que la gráfica *respire*

ylim(h_temp,[min([0 amplitudes*1.2]) max(amplitudes)*1.2])
xlim(h_temp, [0 length(amplitudes)+1])
grid(h_temp, 'on')
