%% Representación gráfica de la densidad espectral y la cota Cramér-Rao

% Definamos algunos puntos donde representar las gráficas
izq   = 0.075   ; bajo  = 0.100;
ancho = 0.90    ; alto  = 0.350;
margen= 0.055   ;

h_color_senal = findobj(gcbf, 'Tag', 'color_senal');
color_linea = get(h_color_senal,'String');

h_panel = findall(gcf, 'Tag', 'panel_grafica');

dep = subplot('Position', [izq bajo+alto+margen ancho 1-1.5*margen-alto-bajo], 'Parent', h_panel);
ccr = subplot('Position', [izq bajo ancho alto], 'Parent', h_panel);

set(dep, 'Tag', 'grafica_dep');
set(ccr, 'Tag', 'grafica_ccr');

h_dep = findobj('Tag', 'grafica_dep');
h_ccr = findobj('Tag', 'grafica_ccr');

h_minZactual = findobj(gcbf, 'Tag', 'minZactual');
h_maxZactual = findobj(gcbf, 'Tag', 'maxZactual');

h_ccr_max_min = findobj(gcbf, 'Tag', 'ancho_banda_receptor');
z = get(h_ccr_max_min, 'UserData');

min_ccr_Actual = z(1);
max_ccr_Actual = z(2);

h_fix = findobj(gcbf, 'Tag', 'fix');
nueva = get(h_fix, 'UserData');

if fix == 1
    set(h_dep, 'NextPlot', 'add');
    set(h_ccr, 'NextPlot', 'add');
    
    set(h_minZactual,'String', num2str(min([ minZ str2num(get(h_minZactual, 'String'))])))
       
    set(h_maxZactual,'String', num2str(max([maxZ str2num(get(h_maxZactual, 'String'))])))
    
    min_ccr_Actual = min( [min_ccr_Actual min(var_tau)] );
    
    max_ccr_Actual = max( [max_ccr_Actual max(var_tau)] );

    rotulos_ccr
    lista = get(h_panel,  'UserData');
    
    if nueva == 1
        rotulo  = char(lista, etiqueta);
    else
        lista = cellstr(lista);
        lista(end) = cellstr(etiqueta);
           
        rotulo  = char(lista);
    end
    
else
    set(h_dep, 'NextPlot', 'replace')
    set(h_ccr, 'NextPlot', 'replace')
    set(h_minZactual,'String', num2str(minZ))
    set(h_maxZactual,'String', num2str(maxZ))
    
    min_ccr_Actual = min(var_tau);
    max_ccr_Actual = max(var_tau);
    
    rotulos_ccr
    rotulo  = char(etiqueta) ;
end

set(h_ccr_max_min, 'userData', [min_ccr_Actual max_ccr_Actual])

plot(dep, eje_x, 10*log10(Z),'Color', str2num(color_linea ))

if nueva == 1 || fix == 0      % si es una gráfica nueva la pintamos
    semilogy(ccr, dB_range , var_tau,'Color', str2num(color_linea),...
        'Tag', 'er_plot')    
                
else    % Si no, simplemente coloreamos con el color que debe tener
    
    h_plot = findobj(gcbf, 'Tag', 'er_plot');
    set(h_plot(1),'Color', str2num(color_linea))
end

y_minimo = str2num(get(h_minZactual,'String'));
y_maximo = str2num(get(h_maxZactual,'String'));

min_dep  = max([10^-6.5 y_minimo]);

% La leyenda

set(h_panel,  'UserData', rotulo)
leyenda = legend(h_ccr, cellstr(get(h_panel, 'UserData')));
set(leyenda,'Position',[0.76 0.38 0.01 0.01 ],'FontSize',8)

% Limites y rejilla

ylim(h_dep,[ 10*log10(min_dep) 10*log10(y_maximo)+2])
ylim(h_ccr, [min_ccr_Actual*0.9 max_ccr_Actual*1.1])
grid(h_dep, 'on')
grid(h_ccr, 'on')
    
