%% Representación gráfica de la autocorrelación y del multipath

% Definamos algunos puntos donde representar las gráficas
% Estos valores corresponden a la gráfica inferior. La superior se
% autoajusta
izq   = 0.075    ; bajo  = 0.057;
ancho = 0.90     ; alto  = 0.350;
margen= 0.05     ;

margen_auto = 0.1;

m_x_chip = T*300;

h_color_senal = findobj(gcbf, 'Tag', 'color_senal');
color_linea = get(h_color_senal,'String');

h_panel = findall(gcf, 'Tag', 'panel_grafica3');

auto  = subplot('Position', [izq bajo+alto+margen ancho 1-1.5*margen-alto-bajo], 'Parent', h_panel);
multi = subplot('Position', [izq bajo ancho alto], 'Parent', h_panel);

set(auto,  'Tag', 'grafica_auto' );
set(multi, 'Tag', 'grafica_multi');

h_auto  = findobj('Tag', 'grafica_auto' );
h_multi = findobj('Tag', 'grafica_multi');
h_e_l   = findobj(gcbf, 'Tag', 'e_l'); 

zz = get(h_auto, 'ylim');

min_Z_actual = zz(1) + margen_auto;
max_Z_actual = zz(2) - margen_auto;

h_Mpath = findobj(gcbf, 'Tag', 'ampli_Mpath');

z = get(h_Mpath, 'UserData');
max_D_actual = z(2);


h_fix = findobj(gcbf, 'Tag', 'fix');
nueva = get(h_fix, 'UserData');

%%
if fix == 1
   
    set(h_auto,  'NextPlot', 'add'); 
    set(h_multi, 'NextPlot', 'add');
    
    min_Z_actual = min ([min_Z_actual min(Z)]);
    
    max_Z_actual = max([max_Z_actual max(Z)]);
    
    max_D_actual = max([max_D_actual max(D)]) ;

    rotulos
    lista = get(h_panel,  'UserData');
        
    if nueva == 1
        rotulo  = char(lista, etiqueta);
    else
        lista = cellstr(lista);
        lista(end) = cellstr(etiqueta);
           
        rotulo  = char(lista);
    end
        
else
    set(h_auto,  'NextPlot', 'replace')
    set(h_multi, 'NextPlot', 'replace')
    
    min_Z_actual = min(Z);
    max_Z_actual = max(Z);
    max_D_actual = max(D);
    
    rotulos
    rotulo  = char(etiqueta) ;
end

set(h_Mpath, 'userData', [-max_D_actual max_D_actual])

%% Pintemos los datos 

if nueva == 1 || fix == 0      % si es una gráfica nueva la pintamos

    plot(auto, [-1.2 -1 eje_x +1 +1.2], [0 0 Z 0 0],...
        'Color', str2num(color_linea), 'LineWidth', 1, 'Tag', 'er_plot')
    
    plot(multi, eje_error, D,...
    'Color', str2num(color_linea),'LineWidth', 1, 'Tag', 'er_plot2')

    set(h_multi, 'NextPlot', 'add')

    plot(multi, [eje_error_min dur_chips_x*m_x_chip 1.65*m_x_chip], [error_min 0 0],...
   'Color', str2num(color_linea),'LineWidth', 1, 'Tag', 'er_plot3')
        
else    % Si no, simplemente coloreamos con el color que debe tener
    
    h_plot = findobj(gcbf, 'Tag', 'er_plot');
    set(h_plot(1),'Color', str2num(color_linea))

    h_plot2 = findobj(gcbf, 'Tag', 'er_plot2');
    set(h_plot2(1),'Color', str2num(color_linea))

    h_plot3 = findobj(gcbf, 'Tag', 'er_plot3');
    set(h_plot3(1),'Color', str2num(color_linea))

end

% La leyenda

set(h_panel,  'UserData', rotulo)

leyenda = legend(h_auto, cellstr(get(h_panel, 'UserData')));
set(leyenda,'Position',[0.775 0.895 0.01 0.01 ],'FontSize',8)

% Ejes
ylim(h_auto, [min_Z_actual-margen_auto max_Z_actual+margen_auto])
xlim(h_auto,[ -1.2 1.2])

xlim(h_multi,[0 1.65]*m_x_chip)
ylim(h_multi,[-max_D_actual max_D_actual]*1.1)

xlabel({'Retardo del multipath [m]'});
ylabel({'Error [m]'});


% Rejilla
grid(h_auto,  'on')
grid(h_multi, 'on')    


