%% Rutina de almacenamiento
% Recabamos la info y la pegamos en el cajetín
% ¿Que info? la necesaria para recrear la señal y solo la señal.

% ¿Que cajetín?

for j = 1 : 4
   
    h1 = findobj( gcbf, 'Tag', ['senal_' num2str(j)] );
    h2 = findobj( gcbf, 'Tag', ['datos_senal_' num2str(j)] );
    
    if  get(h1, 'value') == 1
        cajetin = j;
        h_boton = h1;
        h_cajetin = h2;
    end
end

h_color_senal = findobj(gcbf, 'Tag','color_senal');

h_gnss  = findobj(gcbf, 'Tag', 'desplegable_gnss');
val = get(h_gnss, 'Value');
str = get(h_gnss, 'String');

h1  = findobj(gcbf, 'Tag', 'duracion_senal');
duracion = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'num_muestras');
num_muestras = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'res_senal');
res_senal = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'ampli_Mpath');
alpha = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'e_l');
delta = get(h1, 'String');


switch str{val}
    
    case 'Pulso Rectangular'
      
      dato = ['Rect d:' delta ' a:' alpha ' res:' res_senal ];
      
      datos = {num2str(val); num_muestras; duracion; res_senal;...
          get(h_color_senal, 'String'); alpha ; delta};
   
    case 'SQRRC'
      
       h1 = findobj(gcbf, 'Tag', 'roll_off');
       h2 = findobj(gcbf, 'Tag', 'nss');
       h3 = findobj(gcbf, 'Tag', 'ls');  
      
       dato = ['SQRRC d:' delta ' a:' alpha ' res:' res_senal ];
      
       datos = {num2str(val); get(h1, 'String'); get(h2, 'String');...
           get(h3, 'String'); duracion; res_senal;...
           get(h_color_senal, 'String'); alpha ; delta};
          
    case 'BOC'
       
       h1 = findobj(gcbf, 'Tag', 'BOC_m');
       h2 = findobj(gcbf, 'Tag', 'BOC_n');
       
       dato = ['BOC(' get(h1, 'String') ',' get(h2, 'String') ') ' ...
           'd:' delta ' a:' alpha ' res:' res_senal ]; 
       datos = {num2str(val); get(h1, 'String'); get(h2, 'String');...
           duracion; res_senal; get(h_color_senal, 'String'); alpha ; delta};
       
    case 'GPS-L1'   

       dato = ['GPS-L1 d:' delta ' a:' alpha ' res:' res_senal ]; 
       
       datos = {num2str(val); num_muestras; duracion; res_senal;...
          get(h_color_senal, 'String'); alpha ; delta};
 
       kk=num2str(val)
 
    case 'CBOC Galileo E1'
        
       dato  = ['GalileoE1 d:' delta ' a:' alpha ' res:' res_senal ];
       datos = {num2str(val); duracion; res_senal; get(h_color_senal, 'String');...
           alpha ; delta};
       
    case 'CBOC'
       
       h_m1 = findobj(gcbf, 'Tag', 'cboc_m1');
       h_n1 = findobj(gcbf, 'Tag', 'cboc_n1');
       h_m2 = findobj(gcbf, 'Tag', 'cboc_m2');
       h_n2 = findobj(gcbf, 'Tag', 'cboc_n2');
       h_p1 = findobj(gcbf, 'Tag', 'p1');
       h_p2 = findobj(gcbf, 'Tag', 'p2');
       h_p_m= findobj(gcbf, 'Tag', 'cboc_mas_menos');
       
       m1 = get(h_m1, 'String');
       n1 = get(h_n1, 'String');

       m2 = get(h_m2, 'String');
       n2 = get(h_n2, 'String');

       p1 = get(h_p1, 'String');
       p2 = get(h_p2, 'String');
       
       %tipo = get(h_p_m, 'Value');
       
       if get(h_p_m, 'Value') == 1
           p_m = '-';
       else
           p_m = '+';
       end
       
       dato  = ['CBOC(' p_m ',' m1 ',' m2 ') d:' delta ' a:' alpha ' res:'];
       datos = {num2str(val); m1 ; n1 ; m2 ; n2; p1; p2; duracion;...
           res_senal; get(h_color_senal, 'String');...
           num2str(get(h_p_m, 'Value')); alpha ; delta};
       
end

% Lo que tenemos
set(h_cajetin, 'UserData', datos)

% Lo que vemos
set(h_cajetin, 'String', dato, 'ForegroundColor', str2num(get(h_color_senal, 'String')) )





