% Rutina de almacenamiento
% Recabamos la info y la pegamos en el cajetín
% ¿Que info? la necesaria para recrear la señal y solo la señal.

% ¿Que cajetín?

for j = 1 : 4
   
    h1 = findobj( gcbf, 'Tag', ['senal_' num2str(j)] );
    h2 = findobj( gcbf, 'Tag', ['datos_senal_' num2str(j)] );
    
    if  get(h1, 'value') == 1
        cajetin = j;
        h_boton = h1;
        h_cajetin = h2;
    end
end

h_color_senal = findobj(gcbf, 'Tag','color_senal');

h1  = findobj(gcbf, 'Tag', 'desplegable_gnss');
val = get(h1, 'Value');
str = get(h1,'String');

h1  = findobj(gcbf, 'Tag', 'duracion_senal');
duracion = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'num_muestras');
num_muestras = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'res_senal');
res_senal = get(h1, 'String');

h1 = findobj(gcbf, 'Tag', 'ancho_banda_receptor');
BW = get(h1, 'String');

% Dato es lo que mostramos en el cajetín
% Datos es lo que almacenamos
switch str{val}
    
    case 'Pulso Rectangular'

      dato = ['Pulso ' num_muestras ' BW ' BW 'MHz ' duracion 'us' ];
      datos = {num2str(val); num_muestras; duracion; res_senal;...
          get(h_color_senal, 'String'); BW};
   
    case 'SQRRC'
       
       h1 = findobj(gcbf, 'Tag', 'roll_off');
       h2 = findobj(gcbf, 'Tag', 'nss');
       h3 = findobj(gcbf, 'Tag', 'ls');
       dato = ['SQRRC ' 'B:' get(h1, 'String') ' Nss:' get(h2, 'String')...
           ' S:' get(h3, 'String') ' ' BW 'MHz ' duracion 'us']; 
       datos = {num2str(val); get(h1, 'String'); get(h2, 'String');...
           get(h3, 'String'); duracion; res_senal;...
           get(h_color_senal, 'String'); BW};
    
    case 'BOC'
       
       h1 = findobj(gcbf, 'Tag', 'BOC_m');
       h2 = findobj(gcbf, 'Tag', 'BOC_n');
       
       dato = ['BOC(' get(h1, 'String') ',' get(h2, 'String') ') ' BW 'MHz ' duracion 'us']; 
       datos = {num2str(val); get(h1, 'String'); get(h2, 'String');...
           duracion; res_senal; get(h_color_senal, 'String'); BW};
       
    case 'GPS-L1'   

       dato = ['GPS-L1 ' BW 'MHz ' duracion 'us']; 
       datos = {num2str(val); duracion; res_senal;...
           get(h_color_senal, 'String'); BW};
       
    case 'CBOC Galileo E1'
        
       dato  = ['Galileo E1 ' BW 'MHz ' duracion 'us'];
       datos = {num2str(val); duracion; res_senal; get(h_color_senal, 'String'); BW};
       
end

% Lo que tenemos
set(h_cajetin, 'UserData', datos)

% Lo que vemos
set(h_cajetin, 'String', dato, 'ForegroundColor', str2num(get(h_color_senal, 'String')) )





