% Con los datos contenidos en el cajetín debemos ser capaces de suministrar
% los datos al GUI para poder recrear la señal.
% Para cada señal tenemos un decodificador distinto

h_duracion     = findobj(gcbf, 'Tag', 'duracion_senal');
h_num_muestras = findobj(gcbf, 'Tag', 'num_muestras');
h_res_senal    = findobj(gcbf, 'Tag', 'res_senal');
h_color_senal  = findobj(gcbf, 'Tag', 'color_senal');
h_BW = findobj(gcbf, 'Tag', 'ancho_banda_receptor');

% ¿De que cajetín queremos recuperar los datos?

for j = 1 : 4
   
    h1 = findobj( gcbf, 'Tag', ['senal_' num2str(j)] );
    h2 = findobj( gcbf, 'Tag', ['datos_senal_' num2str(j)] );
    
    if  get(h1, 'value') == 1
        cajetin = j;
        h_boton = h1;
        h_cajetin = h2;
    end
end

dato = get(h_cajetin, 'UserData');

% Actualizamos el desplegable haciendo que apunte al tipo de señal.

h1  = findobj(gcbf, 'Tag', 'desplegable_gnss');

tipo =  str2num(char((dato(1))));
set(h1, 'Value',tipo)

% Para que el generado sepa que no tiene que poner valores por defecto
default = 0;

switch tipo
    case 1  % Se trata de un pulso
                 
        set(h_num_muestras, 'String', char(dato(2)))
        
        set(h_duracion,     'String', char(dato(3))) 
        set(h_res_senal,    'String', char(dato(4)))
        
        set(h_color_senal,  'String', str2num(char(dato(5))))
        
        set(h_BW,           'String', char(dato(6)))
        pulse_generator_ccr;
        
    case 2  % Se trata de un SQRRC
        
        h1 = findobj(gcbf, 'Tag', 'roll_off');
        h2 = findobj(gcbf, 'Tag', 'nss');
        h3 = findobj(gcbf, 'Tag', 'ls');
        
        set(h1, 'String', char(dato(2)));
        set(h2, 'String', char(dato(3)));
        set(h3, 'String', char(dato(4)));
        
        set(h_duracion,     'String', char(dato(5)))   
        set(h_res_senal,    'String', char(dato(6)))
        set(h_color_senal,  'String', str2num(char(dato(7))))
        
        set(h_BW,           'String', char(dato(8)))
        
        sqrrc_generator_ccr;
        
    case 3  % Se trata de una BOC
        
        h1 = findobj(gcbf, 'Tag', 'BOC_m');
        h2 = findobj(gcbf, 'Tag', 'BOC_n');
        
        set(h1, 'String', char(dato(2)))
        set(h2, 'String', char(dato(3)))
        
        set(h_duracion,     'String', char(dato(4)))
        set(h_res_senal,    'String', char(dato(5)))
        set(h_color_senal,  'String', str2num(char(dato(6))))
        
        set(h_BW,           'String', char(dato(7)))
        
        boc_generator_ccr;
        
    case 4  % Se trata de una GPS-L1
    
        set(h_num_muestras, 'String', char(dato(2)))
        
        set(h_duracion,     'String', char(dato(3))) 
        set(h_res_senal,    'String', char(dato(4)))
        
        set(h_color_senal,  'String', str2num(char(dato(5))))
        
        set(h_BW,           'String', char(dato(6)))
                
        gps_L1_generator_ccr;
        
    case 5  % Se trata de una Galileo E1
                
        set(h_duracion,     'String', char(dato(2)))
        set(h_res_senal,    'String', char(dato(3)))
        set(h_color_senal,  'String', str2num(char(dato(4))))
        set(h_BW,           'String', char(dato(5)))
        E1_generator_ccr;
        
end






